SlideShare una empresa de Scribd logo
1 de 20
10 tips for making Bash a sane
programming language
Yaroslav Tkachenko | @sap1ens | sap1ens.com
Senior Data Engineer at Activision
#!/usr/bin/env bash LANG="${LANG:-en}" locale=$(echo $LANG | cut -c1-2) unset configuredClient ## This function determines which http get tool the system has installed and
returns an error if there isnt one getConfiguredClient() { if command -v curl &>/dev/null; then configuredClient="curl" elif command -v wget &>/dev/null; then
configuredClient="wget" elif command -v http &>/dev/null; then configuredClient="httpie" elif command -v fetch &>/dev/null; then configuredClient="fetch" else echo "Error:
This tool reqires either curl, wget, httpie or fetch to be installed." >&2 return 1 fi } ## Allows to call the users configured client without if statements everywhere httpGet() { case
"$configuredClient" in curl) curl -A curl -s "$@" ;; wget) wget -qO- "$@" ;; httpie) http -b GET "$@" ;; fetch) fetch -q "$@" ;; esac } getIPWeather() { country=$(httpGet
ipinfo.io/country) > /dev/null ## grab the country if [[ $country == "US" ]]; then ## if were in the us id rather not use longitude and latitude so the output is nicer city=$(httpGet
ipinfo.io/city) > /dev/null region=$(httpGet ipinfo.io/region) > /dev/null if [[ $(echo $region | wc -w) == 2 ]];then region=$(echo $region | grep -Eo "[A-Z]*" | tr -d "[:space:]") fi
httpGet $locale.wttr.in/$city,$region$1 else ## otherwise we are going to use longitude and latitude location=$(httpGet ipinfo.io/loc) > /dev/null httpGet
$locale.wttr.in/$location$1 fi } getLocationWeather() { args=$(echo "$@" | tr " " + ) httpGet $locale.wttr.in/${args} } checkInternet() { httpGet github.com > /dev/null 2>&1 || { echo
"Error: no active internet connection" >&2; return 1; } # query github with a get request } update() { # To test the tool enter in the defualt values that are in the examples for each
variable repositoryName="Bash-Snippets" #Name of repostiory to be updated ex. Sandman-Lite username that hosts the reposti nameOfInstallFile="install.sh" # change this if the
installer file has a different name be sure to include file extension if there is one latestVersion=$(httpGet https://api.github.com/repos/$githubUserName/$repositoryName/tags |
grep -Eo '"name":.*?[^]",'| head -1 | grep -Eo "[0-9.]+" ) #always grabs the tag without the v option if [[ $currentVersion == "" || $repositoryName == "" || $githubUserName ==
"" || $nameOfInstallFile == "" ]]; then echo "Error: update utility has not been configured correctly." >&2 exit 1 elif [[ $latestVersion == "" ]]; then echo "Error: no active internet
connection" >&2 exit 1 else if [[ "$latestVersion" != "$currentVersion" ]]; then echo "Version $latestVersion available" echo -n "Do you wish to update $repositoryName [Y/n]: "
read -r answer if [[ "$answer" == [Yy] ]]; then cd ~ || { echo 'Update Failed'; exit 1; } if [[ -d ~/$repositoryName ]]; then rm -r -f $repositoryName || { echo "Permissions Error: try
running the update as sudo"; exit 1; } ; fi echo -n "Downloading latest version of: $repositoryName." git clone -q "https://github.com/$githubUserName/$repositoryName" &&
touch .BSnippetsHiddenFile || { echo "Failure!"; exit 1; } & while [ ! -f .BSnippetsHiddenFile ]; do { echo -n "."; sleep 2; };done rm -f .BSnippetsHiddenFile echo "Success!" cd
$repositoryName || { echo 'Update Failed'; exit 1; } git checkout "v$latestVersion" 2> /dev/null || git checkout "$latestVersion" 2> /dev/null || echo "Couldn't git checkout to stable
release, updating to latest commit." chmod a+x install.sh #this might be necessary in your case but wasnt in mine. ./$nameOfInstallFile "update" || exit 1 cd .. rm -r -f
$repositoryName || { echo "Permissions Error: update succesfull but cannot delete temp files located at ~/$repositoryName delete this directory with sudo"; exit 1; } else exit 1 fi
else echo "$repositoryName is already the latest version" fi fi } usage() { cat <<EOF Weather Description: Provides a 3 day forecast on your current location or a specified
location. With no flags Weather will default to your current location. Usage: weather or weather [flag] or weather [country] or weather [city] [state] weather [i][M] get weather in
imperial units, optional M means windspeed in m/s weather [m][M] get weather in metric units, optional M means windspeed in m/s weather [Moon] grabs the phase of the
moon -u Update Bash-Snippet Tools -h Show the help -v Get the tool version Examples: weather weather Paris m weather Tokyo weather Moon weather mM EOF }
getConfiguredClient || exit 1 while getopts "uvh" opt; do case "$opt" in ?) echo "Invalid option: -$OPTARG" >&2 exit 1 ;; h) usage exit 0 ;; v) echo "Version $currentVersion" exit 0
;; u) checkInternet || exit 1 # check if we have a valid internet connection if this isnt true the rest of the script will not work so stop here update || exit 1 exit 0 ;; :) echo "Option -
$OPTARG requires an argument." >&2 exit 1 ;; esac done if [[ $# == "0" ]]; then checkInternet || exit 1 getIPWeather || exit 1 exit 0 elif [[ $1 == "help" || $1 == ":help" ]]; then
usage exit 0 elif [[ $1 == "update" ]]; then checkInternet || exit 1 update || exit 1 exit 0 fi checkInternet || exit 1 if [[ $1 == "m" ]]; then getIPWeather "?m" || exit 1 elif [[ "${@: -1}"
== "m" ]];then args=$( echo "${@:1:(($# - 1))}" ?m | sed s/" "//g) getLocationWeather $args || exit 1 elif [[ $1 == "M" ]]; then getIPWeather "?M" || exit 1 elif [[ "${@: -1}" == "M"
]];then args=$( echo "${@:1:(($# - 1))}" ?M | sed s/" "//g) getLocationWeather $args || exit 1 elif [[ $1 == "mM" || $1 == "Mm" ]]; then getIPWeather "?m?M" || exit 1 elif [[ "${@: -
1}" == "mM" || "${@:-1}" == "Mm" ]];then args=$( echo "${@:1:(($# - 1))}" ?m?M | sed s/" "//g) getLocationWeather $args || exit 1 elif [[ $1 == "iM" || $1 == "Mi" ]]; then
getIPWeather "?u?M" || exit 1 elif [[ "${@: -1}" == "iM" || "${@:-1}" == "Mi" ]];then args=$( echo "${@:1:(($# - 1))}" ?u?M | sed s/" "//g) getLocationWeather $args || exit 1 elif [[ $1
== "i" ]]; then getIPWeather "?u" || exit 1 elif [[ "${@: -1}" == "i" ]];then args=$( echo "${@:1:(($# - 1))}" ?u | sed s/" "//g) getLocationWeather $args || exit 1 else
getLocationWeather "$@" || exit 1 fi
1: Header, part 1
#!/usr/bin/env bash
set -o errexit
set -o pipefail
1: Header, part 2
set -o nounset
[[ "${DEBUG}" == 'true' ]] && set -o xtrace
2: Constants
readonly SOMETHING='immutable value'
3: Variables, part 1
"${variable}"
4: Variables, part 2
string interpolation: "${variable}.yml”
default / fallback value: "${variable:-blah}”
string replacement: "${variable//from/to}"
5: Functions, part 1
_my_function () {
...
}
6: Functions, part 2
_my_function () {
local one_param="$1”
local another_param="$2”
...
}
7: Conditionals
if [[ -f $file1 && ( -d $dir1 || -d $dir2 ) ]]; then
...
fi
8: Includes
readonly BINPATH="$(dirname "$0")"
# ...
source "${BINPATH}/../shared/some_functions"
9: Pipelines
# Short
command1 | command2
# Long
command1 
| command2 
| command3 
| command4
10: Structure, part 1
_main () {}
_usage () {}
_setup () {}
_cleanup () {}
10: Structure, part 2
_cleanup () {
...
}
trap _cleanup TERM INT QUIT
Bonus: Linting
https://www.shellcheck.net
apt-get install shellcheck
brew install shellcheck
...
Bonus: Learn Bash the Hard Way
Bonus: use Python when needed
• “Oh, I didn’t know it’s that hard to implement in bash” → use Python
• “Oh, I wish bash had introduced a package manager” → use Python
• “Oh, we could use that unit testing framework for bash” → use Python
Instead of a Summary
Learn basic building blocks && be consistent!
Thanks!

Más contenido relacionado

La actualidad más candente

Legacy applications - 4Developes konferencja, Piotr Pasich
Legacy applications  - 4Developes konferencja, Piotr PasichLegacy applications  - 4Developes konferencja, Piotr Pasich
Legacy applications - 4Developes konferencja, Piotr Pasich
Piotr Pasich
 
Profile backup mail_atma_script (disk drumu/export)
Profile backup mail_atma_script (disk drumu/export)Profile backup mail_atma_script (disk drumu/export)
Profile backup mail_atma_script (disk drumu/export)
Anar Godjaev
 

La actualidad más candente (20)

Hacking ansible
Hacking ansibleHacking ansible
Hacking ansible
 
Webrtc mojo
Webrtc mojoWebrtc mojo
Webrtc mojo
 
Yurii Bodarev - OTP, Phoenix & Ecto: Three Pillars of Elixir
Yurii Bodarev - OTP, Phoenix & Ecto: Three Pillars of ElixirYurii Bodarev - OTP, Phoenix & Ecto: Three Pillars of Elixir
Yurii Bodarev - OTP, Phoenix & Ecto: Three Pillars of Elixir
 
Web Audio API + AngularJS
Web Audio API + AngularJSWeb Audio API + AngularJS
Web Audio API + AngularJS
 
GenStage and Flow - Jose Valim
GenStage and Flow - Jose Valim GenStage and Flow - Jose Valim
GenStage and Flow - Jose Valim
 
Codementor Office Hours with Eric Chiang: Stdin, Stdout: pup, Go, and life at...
Codementor Office Hours with Eric Chiang: Stdin, Stdout: pup, Go, and life at...Codementor Office Hours with Eric Chiang: Stdin, Stdout: pup, Go, and life at...
Codementor Office Hours with Eric Chiang: Stdin, Stdout: pup, Go, and life at...
 
Creating Your First WordPress Plugin
Creating Your First WordPress PluginCreating Your First WordPress Plugin
Creating Your First WordPress Plugin
 
BASH Variables Part 1: Basic Interpolation
BASH Variables Part 1: Basic InterpolationBASH Variables Part 1: Basic Interpolation
BASH Variables Part 1: Basic Interpolation
 
#SPUG - Legacy applications
#SPUG - Legacy applications#SPUG - Legacy applications
#SPUG - Legacy applications
 
Ansible leveraging 2.0
Ansible leveraging 2.0Ansible leveraging 2.0
Ansible leveraging 2.0
 
Any event intro
Any event introAny event intro
Any event intro
 
Legacy applications - 4Developes konferencja, Piotr Pasich
Legacy applications  - 4Developes konferencja, Piotr PasichLegacy applications  - 4Developes konferencja, Piotr Pasich
Legacy applications - 4Developes konferencja, Piotr Pasich
 
6. Add numbers in Laravel
6. Add numbers in Laravel6. Add numbers in Laravel
6. Add numbers in Laravel
 
Django productivity tips and tricks
Django productivity tips and tricksDjango productivity tips and tricks
Django productivity tips and tricks
 
Profile backup mail_atma_script (disk drumu/export)
Profile backup mail_atma_script (disk drumu/export)Profile backup mail_atma_script (disk drumu/export)
Profile backup mail_atma_script (disk drumu/export)
 
Using Ansible Dynamic Inventory with Amazon EC2
Using Ansible Dynamic Inventory with Amazon EC2Using Ansible Dynamic Inventory with Amazon EC2
Using Ansible Dynamic Inventory with Amazon EC2
 
Scratching the surface of hunky-dory Elixir features
Scratching the surface of hunky-dory Elixir featuresScratching the surface of hunky-dory Elixir features
Scratching the surface of hunky-dory Elixir features
 
Ethiopian multiplication in Perl6
Ethiopian multiplication in Perl6Ethiopian multiplication in Perl6
Ethiopian multiplication in Perl6
 
BSDM with BASH: Command Interpolation
BSDM with BASH: Command InterpolationBSDM with BASH: Command Interpolation
BSDM with BASH: Command Interpolation
 
Findbin libs
Findbin libsFindbin libs
Findbin libs
 

Similar a 10 tips for making Bash a sane programming language

Web development automatisation for fun and profit (Artem Daniliants)
Web development automatisation for fun and profit (Artem Daniliants)Web development automatisation for fun and profit (Artem Daniliants)
Web development automatisation for fun and profit (Artem Daniliants)
LumoSpark
 

Similar a 10 tips for making Bash a sane programming language (20)

Unix 5 en
Unix 5 enUnix 5 en
Unix 5 en
 
Perl basics for Pentesters
Perl basics for PentestersPerl basics for Pentesters
Perl basics for Pentesters
 
Web 8 | Introduction to PHP
Web 8 | Introduction to PHPWeb 8 | Introduction to PHP
Web 8 | Introduction to PHP
 
PHP PPT FILE
PHP PPT FILEPHP PPT FILE
PHP PPT FILE
 
Course 102: Lecture 8: Composite Commands
Course 102: Lecture 8: Composite Commands Course 102: Lecture 8: Composite Commands
Course 102: Lecture 8: Composite Commands
 
Debugging: Rules And Tools - PHPTek 11 Version
Debugging: Rules And Tools - PHPTek 11 VersionDebugging: Rules And Tools - PHPTek 11 Version
Debugging: Rules And Tools - PHPTek 11 Version
 
関西PHP勉強会 php5.4つまみぐい
関西PHP勉強会 php5.4つまみぐい関西PHP勉強会 php5.4つまみぐい
関西PHP勉強会 php5.4つまみぐい
 
The $path to knowledge: What little it take to unit-test Perl.
The $path to knowledge: What little it take to unit-test Perl.The $path to knowledge: What little it take to unit-test Perl.
The $path to knowledge: What little it take to unit-test Perl.
 
My shell
My shellMy shell
My shell
 
ES6: The Awesome Parts
ES6: The Awesome PartsES6: The Awesome Parts
ES6: The Awesome Parts
 
Naughty And Nice Bash Features
Naughty And Nice Bash FeaturesNaughty And Nice Bash Features
Naughty And Nice Bash Features
 
03 tk2123 - pemrograman shell-2
03   tk2123 - pemrograman shell-203   tk2123 - pemrograman shell-2
03 tk2123 - pemrograman shell-2
 
DevOps with Fabric
DevOps with FabricDevOps with Fabric
DevOps with Fabric
 
All I Need to Know I Learned by Writing My Own Web Framework
All I Need to Know I Learned by Writing My Own Web FrameworkAll I Need to Know I Learned by Writing My Own Web Framework
All I Need to Know I Learned by Writing My Own Web Framework
 
Introduction to PowerShell
Introduction to PowerShellIntroduction to PowerShell
Introduction to PowerShell
 
The Unbearable Lightness: Extending the Bash shell
The Unbearable Lightness: Extending the Bash shellThe Unbearable Lightness: Extending the Bash shell
The Unbearable Lightness: Extending the Bash shell
 
Web development automatisation for fun and profit (Artem Daniliants)
Web development automatisation for fun and profit (Artem Daniliants)Web development automatisation for fun and profit (Artem Daniliants)
Web development automatisation for fun and profit (Artem Daniliants)
 
Absolute Beginners Guide to Puppet Through Types - PuppetConf 2014
Absolute Beginners Guide to Puppet Through Types - PuppetConf 2014Absolute Beginners Guide to Puppet Through Types - PuppetConf 2014
Absolute Beginners Guide to Puppet Through Types - PuppetConf 2014
 
Debugging: Rules & Tools
Debugging: Rules & ToolsDebugging: Rules & Tools
Debugging: Rules & Tools
 
Isolated development in python
Isolated development in pythonIsolated development in python
Isolated development in python
 

Más de Yaroslav Tkachenko

Dynamic Change Data Capture with Flink CDC and Consistent Hashing
Dynamic Change Data Capture with Flink CDC and Consistent HashingDynamic Change Data Capture with Flink CDC and Consistent Hashing
Dynamic Change Data Capture with Flink CDC and Consistent Hashing
Yaroslav Tkachenko
 
Быстрая и безболезненная разработка клиентской части веб-приложений
Быстрая и безболезненная разработка клиентской части веб-приложенийБыстрая и безболезненная разработка клиентской части веб-приложений
Быстрая и безболезненная разработка клиентской части веб-приложений
Yaroslav Tkachenko
 

Más de Yaroslav Tkachenko (18)

Dynamic Change Data Capture with Flink CDC and Consistent Hashing
Dynamic Change Data Capture with Flink CDC and Consistent HashingDynamic Change Data Capture with Flink CDC and Consistent Hashing
Dynamic Change Data Capture with Flink CDC and Consistent Hashing
 
Streaming SQL for Data Engineers: The Next Big Thing?
Streaming SQL for Data Engineers: The Next Big Thing?Streaming SQL for Data Engineers: The Next Big Thing?
Streaming SQL for Data Engineers: The Next Big Thing?
 
Apache Flink Adoption at Shopify
Apache Flink Adoption at ShopifyApache Flink Adoption at Shopify
Apache Flink Adoption at Shopify
 
Storing State Forever: Why It Can Be Good For Your Analytics
Storing State Forever: Why It Can Be Good For Your AnalyticsStoring State Forever: Why It Can Be Good For Your Analytics
Storing State Forever: Why It Can Be Good For Your Analytics
 
It's Time To Stop Using Lambda Architecture
It's Time To Stop Using Lambda ArchitectureIt's Time To Stop Using Lambda Architecture
It's Time To Stop Using Lambda Architecture
 
Bravo Six, Going Realtime. Transitioning Activision Data Pipeline to Streaming
Bravo Six, Going Realtime. Transitioning Activision Data Pipeline to StreamingBravo Six, Going Realtime. Transitioning Activision Data Pipeline to Streaming
Bravo Six, Going Realtime. Transitioning Activision Data Pipeline to Streaming
 
Apache Kafka: New Features That You Might Not Know About
Apache Kafka: New Features That You Might Not Know AboutApache Kafka: New Features That You Might Not Know About
Apache Kafka: New Features That You Might Not Know About
 
Building Scalable and Extendable Data Pipeline for Call of Duty Games: Lesson...
Building Scalable and Extendable Data Pipeline for Call of Duty Games: Lesson...Building Scalable and Extendable Data Pipeline for Call of Duty Games: Lesson...
Building Scalable and Extendable Data Pipeline for Call of Duty Games: Lesson...
 
Designing Scalable and Extendable Data Pipeline for Call Of Duty Games
Designing Scalable and Extendable Data Pipeline for Call Of Duty GamesDesigning Scalable and Extendable Data Pipeline for Call Of Duty Games
Designing Scalable and Extendable Data Pipeline for Call Of Duty Games
 
Actors or Not: Async Event Architectures
Actors or Not: Async Event ArchitecturesActors or Not: Async Event Architectures
Actors or Not: Async Event Architectures
 
Kafka Streams: the easiest way to start with stream processing
Kafka Streams: the easiest way to start with stream processingKafka Streams: the easiest way to start with stream processing
Kafka Streams: the easiest way to start with stream processing
 
Building Stateful Microservices With Akka
Building Stateful Microservices With AkkaBuilding Stateful Microservices With Akka
Building Stateful Microservices With Akka
 
Querying Data Pipeline with AWS Athena
Querying Data Pipeline with AWS AthenaQuerying Data Pipeline with AWS Athena
Querying Data Pipeline with AWS Athena
 
Akka Microservices Architecture And Design
Akka Microservices Architecture And DesignAkka Microservices Architecture And Design
Akka Microservices Architecture And Design
 
Why Actor-Based Systems Are The Best For Microservices
Why Actor-Based Systems Are The Best For MicroservicesWhy Actor-Based Systems Are The Best For Microservices
Why Actor-Based Systems Are The Best For Microservices
 
Why actor-based systems are the best for microservices
Why actor-based systems are the best for microservicesWhy actor-based systems are the best for microservices
Why actor-based systems are the best for microservices
 
Building Eventing Systems for Microservice Architecture
Building Eventing Systems for Microservice Architecture  Building Eventing Systems for Microservice Architecture
Building Eventing Systems for Microservice Architecture
 
Быстрая и безболезненная разработка клиентской части веб-приложений
Быстрая и безболезненная разработка клиентской части веб-приложенийБыстрая и безболезненная разработка клиентской части веб-приложений
Быстрая и безболезненная разработка клиентской части веб-приложений
 

Último

%+27788225528 love spells in Huntington Beach Psychic Readings, Attraction sp...
%+27788225528 love spells in Huntington Beach Psychic Readings, Attraction sp...%+27788225528 love spells in Huntington Beach Psychic Readings, Attraction sp...
%+27788225528 love spells in Huntington Beach Psychic Readings, Attraction sp...
masabamasaba
 
%+27788225528 love spells in Toronto Psychic Readings, Attraction spells,Brin...
%+27788225528 love spells in Toronto Psychic Readings, Attraction spells,Brin...%+27788225528 love spells in Toronto Psychic Readings, Attraction spells,Brin...
%+27788225528 love spells in Toronto Psychic Readings, Attraction spells,Brin...
masabamasaba
 
+971565801893>>SAFE AND ORIGINAL ABORTION PILLS FOR SALE IN DUBAI AND ABUDHAB...
+971565801893>>SAFE AND ORIGINAL ABORTION PILLS FOR SALE IN DUBAI AND ABUDHAB...+971565801893>>SAFE AND ORIGINAL ABORTION PILLS FOR SALE IN DUBAI AND ABUDHAB...
+971565801893>>SAFE AND ORIGINAL ABORTION PILLS FOR SALE IN DUBAI AND ABUDHAB...
Health
 

Último (20)

%in Midrand+277-882-255-28 abortion pills for sale in midrand
%in Midrand+277-882-255-28 abortion pills for sale in midrand%in Midrand+277-882-255-28 abortion pills for sale in midrand
%in Midrand+277-882-255-28 abortion pills for sale in midrand
 
%+27788225528 love spells in Huntington Beach Psychic Readings, Attraction sp...
%+27788225528 love spells in Huntington Beach Psychic Readings, Attraction sp...%+27788225528 love spells in Huntington Beach Psychic Readings, Attraction sp...
%+27788225528 love spells in Huntington Beach Psychic Readings, Attraction sp...
 
Artyushina_Guest lecture_YorkU CS May 2024.pptx
Artyushina_Guest lecture_YorkU CS May 2024.pptxArtyushina_Guest lecture_YorkU CS May 2024.pptx
Artyushina_Guest lecture_YorkU CS May 2024.pptx
 
Crypto Cloud Review - How To Earn Up To $500 Per DAY Of Bitcoin 100% On AutoP...
Crypto Cloud Review - How To Earn Up To $500 Per DAY Of Bitcoin 100% On AutoP...Crypto Cloud Review - How To Earn Up To $500 Per DAY Of Bitcoin 100% On AutoP...
Crypto Cloud Review - How To Earn Up To $500 Per DAY Of Bitcoin 100% On AutoP...
 
WSO2CON 2024 - Building the API First Enterprise – Running an API Program, fr...
WSO2CON 2024 - Building the API First Enterprise – Running an API Program, fr...WSO2CON 2024 - Building the API First Enterprise – Running an API Program, fr...
WSO2CON 2024 - Building the API First Enterprise – Running an API Program, fr...
 
WSO2CON 2024 - Navigating API Complexity: REST, GraphQL, gRPC, Websocket, Web...
WSO2CON 2024 - Navigating API Complexity: REST, GraphQL, gRPC, Websocket, Web...WSO2CON 2024 - Navigating API Complexity: REST, GraphQL, gRPC, Websocket, Web...
WSO2CON 2024 - Navigating API Complexity: REST, GraphQL, gRPC, Websocket, Web...
 
%in Benoni+277-882-255-28 abortion pills for sale in Benoni
%in Benoni+277-882-255-28 abortion pills for sale in Benoni%in Benoni+277-882-255-28 abortion pills for sale in Benoni
%in Benoni+277-882-255-28 abortion pills for sale in Benoni
 
%in Bahrain+277-882-255-28 abortion pills for sale in Bahrain
%in Bahrain+277-882-255-28 abortion pills for sale in Bahrain%in Bahrain+277-882-255-28 abortion pills for sale in Bahrain
%in Bahrain+277-882-255-28 abortion pills for sale in Bahrain
 
%+27788225528 love spells in Toronto Psychic Readings, Attraction spells,Brin...
%+27788225528 love spells in Toronto Psychic Readings, Attraction spells,Brin...%+27788225528 love spells in Toronto Psychic Readings, Attraction spells,Brin...
%+27788225528 love spells in Toronto Psychic Readings, Attraction spells,Brin...
 
+971565801893>>SAFE AND ORIGINAL ABORTION PILLS FOR SALE IN DUBAI AND ABUDHAB...
+971565801893>>SAFE AND ORIGINAL ABORTION PILLS FOR SALE IN DUBAI AND ABUDHAB...+971565801893>>SAFE AND ORIGINAL ABORTION PILLS FOR SALE IN DUBAI AND ABUDHAB...
+971565801893>>SAFE AND ORIGINAL ABORTION PILLS FOR SALE IN DUBAI AND ABUDHAB...
 
WSO2CON 2024 - Cloud Native Middleware: Domain-Driven Design, Cell-Based Arch...
WSO2CON 2024 - Cloud Native Middleware: Domain-Driven Design, Cell-Based Arch...WSO2CON 2024 - Cloud Native Middleware: Domain-Driven Design, Cell-Based Arch...
WSO2CON 2024 - Cloud Native Middleware: Domain-Driven Design, Cell-Based Arch...
 
WSO2CON 2024 - WSO2's Digital Transformation Journey with Choreo: A Platforml...
WSO2CON 2024 - WSO2's Digital Transformation Journey with Choreo: A Platforml...WSO2CON 2024 - WSO2's Digital Transformation Journey with Choreo: A Platforml...
WSO2CON 2024 - WSO2's Digital Transformation Journey with Choreo: A Platforml...
 
tonesoftg
tonesoftgtonesoftg
tonesoftg
 
WSO2Con2024 - Enabling Transactional System's Exponential Growth With Simplicity
WSO2Con2024 - Enabling Transactional System's Exponential Growth With SimplicityWSO2Con2024 - Enabling Transactional System's Exponential Growth With Simplicity
WSO2Con2024 - Enabling Transactional System's Exponential Growth With Simplicity
 
Architecture decision records - How not to get lost in the past
Architecture decision records - How not to get lost in the pastArchitecture decision records - How not to get lost in the past
Architecture decision records - How not to get lost in the past
 
%in kempton park+277-882-255-28 abortion pills for sale in kempton park
%in kempton park+277-882-255-28 abortion pills for sale in kempton park %in kempton park+277-882-255-28 abortion pills for sale in kempton park
%in kempton park+277-882-255-28 abortion pills for sale in kempton park
 
%in tembisa+277-882-255-28 abortion pills for sale in tembisa
%in tembisa+277-882-255-28 abortion pills for sale in tembisa%in tembisa+277-882-255-28 abortion pills for sale in tembisa
%in tembisa+277-882-255-28 abortion pills for sale in tembisa
 
WSO2CON 2024 Slides - Open Source to SaaS
WSO2CON 2024 Slides - Open Source to SaaSWSO2CON 2024 Slides - Open Source to SaaS
WSO2CON 2024 Slides - Open Source to SaaS
 
Direct Style Effect Systems - The Print[A] Example - A Comprehension Aid
Direct Style Effect Systems -The Print[A] Example- A Comprehension AidDirect Style Effect Systems -The Print[A] Example- A Comprehension Aid
Direct Style Effect Systems - The Print[A] Example - A Comprehension Aid
 
What Goes Wrong with Language Definitions and How to Improve the Situation
What Goes Wrong with Language Definitions and How to Improve the SituationWhat Goes Wrong with Language Definitions and How to Improve the Situation
What Goes Wrong with Language Definitions and How to Improve the Situation
 

10 tips for making Bash a sane programming language

  • 1. 10 tips for making Bash a sane programming language Yaroslav Tkachenko | @sap1ens | sap1ens.com Senior Data Engineer at Activision
  • 2. #!/usr/bin/env bash LANG="${LANG:-en}" locale=$(echo $LANG | cut -c1-2) unset configuredClient ## This function determines which http get tool the system has installed and returns an error if there isnt one getConfiguredClient() { if command -v curl &>/dev/null; then configuredClient="curl" elif command -v wget &>/dev/null; then configuredClient="wget" elif command -v http &>/dev/null; then configuredClient="httpie" elif command -v fetch &>/dev/null; then configuredClient="fetch" else echo "Error: This tool reqires either curl, wget, httpie or fetch to be installed." >&2 return 1 fi } ## Allows to call the users configured client without if statements everywhere httpGet() { case "$configuredClient" in curl) curl -A curl -s "$@" ;; wget) wget -qO- "$@" ;; httpie) http -b GET "$@" ;; fetch) fetch -q "$@" ;; esac } getIPWeather() { country=$(httpGet ipinfo.io/country) > /dev/null ## grab the country if [[ $country == "US" ]]; then ## if were in the us id rather not use longitude and latitude so the output is nicer city=$(httpGet ipinfo.io/city) > /dev/null region=$(httpGet ipinfo.io/region) > /dev/null if [[ $(echo $region | wc -w) == 2 ]];then region=$(echo $region | grep -Eo "[A-Z]*" | tr -d "[:space:]") fi httpGet $locale.wttr.in/$city,$region$1 else ## otherwise we are going to use longitude and latitude location=$(httpGet ipinfo.io/loc) > /dev/null httpGet $locale.wttr.in/$location$1 fi } getLocationWeather() { args=$(echo "$@" | tr " " + ) httpGet $locale.wttr.in/${args} } checkInternet() { httpGet github.com > /dev/null 2>&1 || { echo "Error: no active internet connection" >&2; return 1; } # query github with a get request } update() { # To test the tool enter in the defualt values that are in the examples for each variable repositoryName="Bash-Snippets" #Name of repostiory to be updated ex. Sandman-Lite username that hosts the reposti nameOfInstallFile="install.sh" # change this if the installer file has a different name be sure to include file extension if there is one latestVersion=$(httpGet https://api.github.com/repos/$githubUserName/$repositoryName/tags | grep -Eo '"name":.*?[^]",'| head -1 | grep -Eo "[0-9.]+" ) #always grabs the tag without the v option if [[ $currentVersion == "" || $repositoryName == "" || $githubUserName == "" || $nameOfInstallFile == "" ]]; then echo "Error: update utility has not been configured correctly." >&2 exit 1 elif [[ $latestVersion == "" ]]; then echo "Error: no active internet connection" >&2 exit 1 else if [[ "$latestVersion" != "$currentVersion" ]]; then echo "Version $latestVersion available" echo -n "Do you wish to update $repositoryName [Y/n]: " read -r answer if [[ "$answer" == [Yy] ]]; then cd ~ || { echo 'Update Failed'; exit 1; } if [[ -d ~/$repositoryName ]]; then rm -r -f $repositoryName || { echo "Permissions Error: try running the update as sudo"; exit 1; } ; fi echo -n "Downloading latest version of: $repositoryName." git clone -q "https://github.com/$githubUserName/$repositoryName" && touch .BSnippetsHiddenFile || { echo "Failure!"; exit 1; } & while [ ! -f .BSnippetsHiddenFile ]; do { echo -n "."; sleep 2; };done rm -f .BSnippetsHiddenFile echo "Success!" cd $repositoryName || { echo 'Update Failed'; exit 1; } git checkout "v$latestVersion" 2> /dev/null || git checkout "$latestVersion" 2> /dev/null || echo "Couldn't git checkout to stable release, updating to latest commit." chmod a+x install.sh #this might be necessary in your case but wasnt in mine. ./$nameOfInstallFile "update" || exit 1 cd .. rm -r -f $repositoryName || { echo "Permissions Error: update succesfull but cannot delete temp files located at ~/$repositoryName delete this directory with sudo"; exit 1; } else exit 1 fi else echo "$repositoryName is already the latest version" fi fi } usage() { cat <<EOF Weather Description: Provides a 3 day forecast on your current location or a specified location. With no flags Weather will default to your current location. Usage: weather or weather [flag] or weather [country] or weather [city] [state] weather [i][M] get weather in imperial units, optional M means windspeed in m/s weather [m][M] get weather in metric units, optional M means windspeed in m/s weather [Moon] grabs the phase of the moon -u Update Bash-Snippet Tools -h Show the help -v Get the tool version Examples: weather weather Paris m weather Tokyo weather Moon weather mM EOF } getConfiguredClient || exit 1 while getopts "uvh" opt; do case "$opt" in ?) echo "Invalid option: -$OPTARG" >&2 exit 1 ;; h) usage exit 0 ;; v) echo "Version $currentVersion" exit 0 ;; u) checkInternet || exit 1 # check if we have a valid internet connection if this isnt true the rest of the script will not work so stop here update || exit 1 exit 0 ;; :) echo "Option - $OPTARG requires an argument." >&2 exit 1 ;; esac done if [[ $# == "0" ]]; then checkInternet || exit 1 getIPWeather || exit 1 exit 0 elif [[ $1 == "help" || $1 == ":help" ]]; then usage exit 0 elif [[ $1 == "update" ]]; then checkInternet || exit 1 update || exit 1 exit 0 fi checkInternet || exit 1 if [[ $1 == "m" ]]; then getIPWeather "?m" || exit 1 elif [[ "${@: -1}" == "m" ]];then args=$( echo "${@:1:(($# - 1))}" ?m | sed s/" "//g) getLocationWeather $args || exit 1 elif [[ $1 == "M" ]]; then getIPWeather "?M" || exit 1 elif [[ "${@: -1}" == "M" ]];then args=$( echo "${@:1:(($# - 1))}" ?M | sed s/" "//g) getLocationWeather $args || exit 1 elif [[ $1 == "mM" || $1 == "Mm" ]]; then getIPWeather "?m?M" || exit 1 elif [[ "${@: - 1}" == "mM" || "${@:-1}" == "Mm" ]];then args=$( echo "${@:1:(($# - 1))}" ?m?M | sed s/" "//g) getLocationWeather $args || exit 1 elif [[ $1 == "iM" || $1 == "Mi" ]]; then getIPWeather "?u?M" || exit 1 elif [[ "${@: -1}" == "iM" || "${@:-1}" == "Mi" ]];then args=$( echo "${@:1:(($# - 1))}" ?u?M | sed s/" "//g) getLocationWeather $args || exit 1 elif [[ $1 == "i" ]]; then getIPWeather "?u" || exit 1 elif [[ "${@: -1}" == "i" ]];then args=$( echo "${@:1:(($# - 1))}" ?u | sed s/" "//g) getLocationWeather $args || exit 1 else getLocationWeather "$@" || exit 1 fi
  • 3. 1: Header, part 1 #!/usr/bin/env bash set -o errexit set -o pipefail
  • 4. 1: Header, part 2 set -o nounset [[ "${DEBUG}" == 'true' ]] && set -o xtrace
  • 6. 3: Variables, part 1 "${variable}"
  • 7. 4: Variables, part 2 string interpolation: "${variable}.yml” default / fallback value: "${variable:-blah}” string replacement: "${variable//from/to}"
  • 8. 5: Functions, part 1 _my_function () { ... }
  • 9. 6: Functions, part 2 _my_function () { local one_param="$1” local another_param="$2” ... }
  • 10. 7: Conditionals if [[ -f $file1 && ( -d $dir1 || -d $dir2 ) ]]; then ... fi
  • 11. 8: Includes readonly BINPATH="$(dirname "$0")" # ... source "${BINPATH}/../shared/some_functions"
  • 12. 9: Pipelines # Short command1 | command2 # Long command1 | command2 | command3 | command4
  • 13. 10: Structure, part 1 _main () {} _usage () {} _setup () {} _cleanup () {}
  • 14. 10: Structure, part 2 _cleanup () { ... } trap _cleanup TERM INT QUIT
  • 15. Bonus: Linting https://www.shellcheck.net apt-get install shellcheck brew install shellcheck ...
  • 16.
  • 17. Bonus: Learn Bash the Hard Way
  • 18. Bonus: use Python when needed • “Oh, I didn’t know it’s that hard to implement in bash” → use Python • “Oh, I wish bash had introduced a package manager” → use Python • “Oh, we could use that unit testing framework for bash” → use Python
  • 19. Instead of a Summary Learn basic building blocks && be consistent!

Notas del editor

  1. Intro
  2. - Bash is hard (not a typical PL) and weird
  3. Quotes help to prevent issues with spaces (for example) filenames Brace expansion (curly braces) are very helpful for various string manipulations
  4. Don’t need to write “function” anymore (legacy) Use some way to namespace your functions (for example, underscore)
  5. - Double square brackets generally offer cleaner syntax, you don’t need to escape anything inside and they also provide some additional features (like pattern matching or Regex expressions)
  6. - Make sure to define something like BINPATH variable to be able to always call script correctly from any directory - Include itself is not always a best practice (due to security concerns and the fact that scripts includes EVERYTHING, there are no private variables/functions in bash)